<?php

namespace common\logic\Document\DeliveryNote\Event;

use common\logic\Document\DeliveryNote\Event\DeliveryNoteCreateEvent;
use common\logic\Document\DeliveryNote\Model\DeliveryNote;
use common\logic\Document\Document\Module\DocumentModule;
use common\logic\Order\Order\Module\OrderModule;
use common\logic\Producer\Producer\Module\ProducerModule;
use justcoded\yii2\eventlistener\observers\Observer;

class DeliveryNoteObserver extends Observer
{
    public function events()
    {
        return [
            DeliveryNote::EVENT_CREATE => 'onDeliveryNoteCreate'
        ];
    }

    public function onDeliveryNoteCreate(DeliveryNoteCreateEvent $event)
    {
        $producerModule = ProducerModule::getInstance();
        $documentModule = DocumentModule::getInstance();

        if($producerModule->getSolver()->getConfig('delivery_note_automatic_validation')) {
            $documentModule->getManager()->validateDocument($event->deliveryNote);
        }
    }
}